#if !defined _SSCornerLath_HEADER 
#define _SSCornerLath_HEADER

#include "SSLath.h"
#include "SSVertex.h"

// Specialization of lath for the corner lath structure
// See method descriptions in file SSLath.h
class SSCornerLath : public SSLath
{
public:
  virtual SSLath *cwv()
  {
    SSLath *tmp = this;
    tmp = tmp->ccwf()->ccwv();
    if(tmp) {
      return tmp->ccwf();
    } else {
      tmp = this;
      while(tmp && tmp->ccwv() != this) { tmp = tmp->ccwv(); }
      return tmp;    // May be null => no clockwise neighbour
    }
  };

  virtual SSLath *ccwv()
  {
    return m_ccwnextv;
  };

  virtual SSLath *cwf()
  {       
    SSLath *tmp = this;

    while(tmp && tmp->ccwf() != this) { tmp = tmp->ccwf(); };

    return tmp;
  };

  virtual SSLath *ccwf()
  {
    return m_ccwnextf;
  };

  virtual SSLath *nl()
  {
    return m_nextlevel;
  };

  virtual SSVertex corner() const 
  {
    return m_corner;
  };
        
  virtual void ccwnextf(SSLath *lath)
  {
    m_ccwnextf = lath;
  };

  virtual void ccwnextv(SSLath *lath)
  {
    m_ccwnextv = lath;
  };

  virtual void nextlevel(SSLath *lath)
  {
    m_nextlevel = lath;
  };

  virtual ostream& put(ostream &s) const;

  virtual bool isvisited() const
  {
    return m_visited;
  }

  virtual void visited(bool b)
  {
    m_visited = b;
  }
        
  virtual void setcwknotspc(KnotSpacingType spc)
  {
    m_cwknot = spc;
  }

  virtual void setccwknotspc(KnotSpacingType spc)
  {
    m_ccwknot = spc;
  }

  virtual KnotSpacingType ccwknotspc() const
  {
    return m_ccwknot;
  }
        
  virtual KnotSpacingType cwknotspc() const
  {
    return m_cwknot;
  }

  virtual KnotSpacingType knotspc(int,int,int) const;

  virtual ~SSCornerLath();

  SSCornerLath(SSVertex corner);

private:
  SSVertex m_corner;
  SSLath *m_nextlevel;
  SSLath *m_ccwnextv;
  SSLath *m_ccwnextf;
  KnotSpacingType m_ccwknot, m_cwknot;
  bool m_visited;
};

ostream& operator<<(ostream &s, SSLath &l);
ostream& operator<<(ostream &s, SSLath *l);

#endif
