#if !defined _SSDooSabin_HEADER 
#define _SSDooSabin_HEADER

#include "SSMaster.h"
#include "SSSubdivideMethods.h"

// Implements Doo-Sabin subdivision
class SSDooSabin : public SSSubdivideMethods
{
public:
  virtual SSLath *Subdivision(vector<SSLath*> &vec, SSLath *start);

  SSDooSabin();

  virtual ~SSDooSabin();

private:
  vector<CoefficientType> CalcCoeff(int valence);
  void Subdivide(vector<SSLath*> &vec, SSLath *start);

  // Coefficients for regular case, i.e. quadrilaterals
  static const CoefficientType regcoeff[];
};
        
#endif
