#if !defined _SSHeroReader_HEADER 
#define _SSHeroReader_HEADER

#include <fstream>
#include <string>
#include <utility>
#include <map>
#include <vector>
#include "SSLath.h"
#include "SSVertex.h"
#include "SSReader.h"

// Reader for a subset of VRML2
class SSHeroReader
{

public:
  virtual bool read(const string filename, vector<SSLath*> &faces);
    
  virtual ~SSHeroReader();
  SSHeroReader();

private:
  enum io_status { IO_GOOD, IO_EOF, IO_FAIL, IO_NEXTSECTION };
  struct Match { int edge; SSLath *face; };
  typedef struct Match Match;


  io_status ReadLine(ifstream &is);
  void DoNextSection(ifstream &is);
  void ReadVertices(ifstream &is);
  void ReadFaces(ifstream &is);
  bool BuildModel(vector<SSLath*> &faces);
  void GetVertices();
  void GetFaceIndex();
  void DumpAll();
  int hash(int v1, int v2);
  void ConnectFaces(vector< vector<int> > &hashtable, vector<SSLath*> &faces);
  Match FindMatch(vector<vector<int> > &hashtable, vector<SSLath*> &faces, int v1, int v2);
  char m_currentline[1024];
  string m_nextsection;
  long m_lineno;
  int m_numberoffaces;

  vector<SSVertex> m_vertices;
  map<int, vector<int> > m_faces;
    
};

#endif
