#if !defined _SSMdlReader_HEADER 
#define _SSMdlReader_HEADER

#include <fstream>
#include <string>
#include <utility>
#include <map>
#include <vector>
#include "SSLath.h"
#include "SSVertex.h"
#include "SSReader.h"

// Reader for the MDL format
class SSMdlReader : SSReader
{
 private:
  char buf[1024];
  string modedata;
  double coorddata1, coorddata2, coorddata3;
  int numdata, vnumdata;
  map<int, vector<int> > facedata;
  map<int, SSVertex> vertices;
  vector<pair<int, int> > connections;
  map<int, vector<double> > knotspacings;
  int lineno;
  int stat, pushbackflag;
  enum status { IO_GOOD = 0, IO_EOF = 1, IO_FAIL = 2 };
  status pushbackstat;

  void pushback();
  status readLine(ifstream &in);
  void error(string msg, int io);
  void readVertices(ifstream &in);
  void readFaces(ifstream &in);
  void readConnections(ifstream &in);
  void readKnotSpacings(ifstream &in);
  pair<int, int> findEdgeNo(const vector<int> &vec1, const vector<int> &vec2, int f1, int f2);
  void buildModel(vector<SSLath*> &faces);

 public:
  virtual void read(const string &filename, vector<SSLath*> &faces);
  virtual ~SSMdlReader() {}
};

#endif
