#if !defined _SSReader_HEADER 
#define _SSReader_HEADER

#include <string>
#include "SSModel.h"
#include "SSLath.h"

// Base class for model readers
class SSReader
{
public:
  // Reads a model from the file filename, storing one lath pointer in faces
  // for each face in the polygonal model
  virtual void read(const string &filename, vector<SSLath*> &faces) = 0;

  // Destructor for clean-up
  virtual ~SSReader() {}
};

#endif
